'*******************************************************************************
'                              Force Feedback Wheel
'                         - Logitech Driving Force Pro -
'*******************************************************************************
'                             BASCOM-AVR v.2.0.7.6
'                                MrShilov 2013
$hwstack = 40
$swstack = 40
$framesize = 50
$regfile = "m8def.dat"
$crystal = 12000000
Config Error = Ignore , 380 = Ignore                        '  BASCOM-AVR .2.0.7.6  
$include "Usb_config.inc"
'*******************************************************************************
Ffb_motor Alias Portb.4
Row0 Alias Portc.5
Row1 Alias Portd.0
Row2 Alias Portd.1
Row3 Alias Portd.4
Col0 Alias Pind.5
Col1 Alias Pind.6
Col2 Alias Pind.7
Col3 Alias Pinb.0
Col5 Alias Pinb.1

Dim Resetcounter As Word
Dim Idlemode As Byte
Dim Accelerator As Byte
Dim Brake As Byte
Dim Combined_pedals As Byte
Dim Temp_word As Word
Dim Temp_long As Dword
Dim Wheel As Word
Dim Buttons As Word
Dim Hat As Byte
Dim I As Byte
Dim Ffb_data As Byte
Dim Sensitivity As Dword

Config Timer2 = Pwm , Prescale = 32 , Compare Pwm = Clear Up
Tccr2.3 = 1                                                 ' FastPWM -  1,5
Tccr2.6 = 1
Pwm2 = 128

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'*********************************  ***********************************
Enable Interrupts
Gosub Clear_ports

Do

Resetcounter = 0
   While _usb_pin._usb_dminus = 0                           ' 
      Incr Resetcounter
      If Resetcounter = 1000 Then
         Call Usb_reset()
      End If
   Wend

   If _usb_status._usb_rxc = 1 Then                         '   
      If _usb_status._usb_setup = 1 Then
         Call Usb_processsetup(_usb_tx_status)

      Elseif _usb_status._usb_endp1 = 1 Then                '  
         Select Case _usb_rx_buffer(2)
            Case 17
               Ffb_motor = 1                                '  FFB
               Ffb_data = _usb_rx_buffer(4)                 ' FFB
            Case 19 : Ffb_motor = 0                         '  FFB
         End Select

      End If

      _usb_status._usb_rtr = 1                              ' RTR-  (   )
      _usb_status._usb_rxc = 0                              ' RXC-

   End If

   If _usb_tx_status2._usb_txc = 1 Then                     '   

      '---------------------    -----------------------------
      Wheel = 0
      For I = 1 To 16                                       '16    ""
         Temp_word = Getadc(0)
         Wheel = Wheel + Temp_word
      Next I

      '------------------------   -------------------------------
      Buttons = 0
      Gosub Clear_ports : Config Row0 = Output : Row0 = 0 : Waitus 50
         Buttons.1 = Not Col0                               '1 - "/\"
         Buttons.3 = Not Col1                               '5 - "L1"
         Buttons.9 = Not Col2                               '9 - "L3"
         Hat.0 = Not Col5                                   '21 - Hat "1"

      Gosub Clear_ports : Config Row1 = Output : Row1 = 0 : Waitus 50
         Wheel.15 = Not Col0                                '2 - "[]"
         Buttons.2 = Not Col1                               '6 - "R1"
         Buttons.8 = Not Col2                               '10 - "R3"
         Hat.1 = Not Col5                                   '22 - Hat "2"

      Gosub Clear_ports : Config Row2 = Output : Row2 = 0 : Waitus 50
         Buttons.0 = Not Col0                               '3 - "O"
         Buttons.5 = Not Col1                               '7 - "L2"
         Buttons.6 = Not Col2                               '11 - "Select"
         Buttons.10 = Not Col3                              '15 - "Gear Up"
         Hat.2 = Not Col5                                   '23 - Hat "3"

      Gosub Clear_ports : Config Row3 = Output : Row3 = 0 : Waitus 50
         Wheel.14 = Not Col0                                '4 - "X"
         Buttons.4 = Not Col1                               '8 - "R2"
         Buttons.7 = Not Col2                               '12 - "Start"
         Buttons.11 = Not Col3                              '16 - "Gear Down"
         Hat.3 = Not Col5                                   '24 - Hat "4"
      Gosub Clear_ports

         Select Case Hat
            Case 0 : Buttons.15 = 1                         'Hat  
            'Case 1                                          ' /\ ,   = 0
            Case 2 : Buttons.13 = 1                         ' >
            Case 3 : Buttons.12 = 1                         ' /\  >
            Case 4 : Buttons.14 = 1                         ' \/
            Case 6
               Buttons.12 = 1 : Buttons.13 = 1              ' >  \/
            Case 8
               Buttons.13 = 1 : Buttons.14 = 1              ' <
            Case 9
               Buttons.12 = 1
               Buttons.13 = 1 : Buttons.14 = 1              ' <  /\
            Case 12
               Buttons.12 = 1 : Buttons.14 = 1              ' <  \/
         End Select

      '-------------------------   -----------------------------
      Temp_word = Getadc(2)                                 ' ""
      Shift Temp_word , Right , 2
      Brake = Temp_word
      Temp_word = Getadc(3)                                 ' ""
      Shift Temp_word , Right , 2
      Accelerator = Temp_word

      Combined_pedals = Accelerator / 2
      If Brake < 250 Then                                   '  
         Combined_pedals = Brake / 2
         Combined_pedals = 255 - Combined_pedals
      End If

      '--------------------   -------------------------
      Sensitivity = 0
      For I = 1 To 4
         Temp_long = Getadc(1)
         Sensitivity = Sensitivity + Temp_long
      Next I
      Temp_long = Sensitivity + 1024
      Temp_long = Temp_long * Ffb_data
      Temp_long = Temp_long / 5120                          '20%...100% FFB
      Pwm2 = Temp_long

      '-----------------------     ----------------------------
      _usb_tx_buffer2(2) = Low(wheel)
      _usb_tx_buffer2(3) = High(wheel)
      _usb_tx_buffer2(4) = Low(buttons)
      _usb_tx_buffer2(5) = High(buttons)
      _usb_tx_buffer2(6) = Accelerator
      _usb_tx_buffer2(7) = Brake
      _usb_tx_buffer2(8) = Combined_pedals
      Call Usb_send(_usb_tx_status2 , 7)
   End If

Loop

End
'===============================================================================
Clear_ports:
Config Row0 = Input : Row0 = 1
Config Row1 = Input : Row1 = 1
Config Row2 = Input : Row2 = 1
Config Row3 = Input : Row3 = 1
Return

$include "Descriptors.inc"