'*******************************************************************************
'                              Force Feedback Wheel
'                                - Logitech G25 -
'*******************************************************************************
'                             BASCOM-AVR v.2.0.7.6
'                                MrShilov 2013
$hwstack = 40
$swstack = 40
$framesize = 50
$regfile = "m8def.dat"
$crystal = 12000000
Config Error = Ignore , 380 = Ignore                        '  BASCOM-AVR .2.0.7.6  
$include "Usb_config.inc"
'*******************************************************************************
Ffb_motor Alias Portb.4
Row0 Alias Portc.5
Row1 Alias Portd.0
Row2 Alias Portd.1
Row3 Alias Portd.4
Col0 Alias Pind.5
Col1 Alias Pind.6
Col2 Alias Pind.7
Col3 Alias Pinb.0
Col4 Alias Pinb.2
Col5 Alias Pinb.1

Dim Resetcounter As Word
Dim Idlemode As Byte
Dim Accelerator As Word
Dim Brake As Word
Dim Clutch As Word
Dim Combined_pedals As Byte
Dim Temp_word As Word
Dim Wheel As Word
Dim Buttons As Word
Dim Buffer_6 As Byte
Dim Buffer_7 As Byte
Dim Buffer_8 As Byte
Dim Hat As Byte
Dim I As Byte
Dim Int_temp As Integer

Config Timer2 = Pwm , Prescale = 32 , Compare Pwm = Clear Up
Tccr2.3 = 1                                                 ' FastPWM -  1,5
Tccr2.6 = 1
Pwm2 = 128

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'*********************************  ***********************************
Enable Interrupts
Gosub Clear_ports

Do

   Resetcounter = 0
   While _usb_pin._usb_dminus = 0                           ' 
      Incr Resetcounter
      If Resetcounter = 1000 Then
         Call Usb_reset()
      End If
   Wend

   '-----------------------   USB ---------------------------------------
   If _usb_status._usb_rxc = 1 Then                         '   
      If _usb_status._usb_setup = 1 Then                    ' 
         Call Usb_processsetup(_usb_tx_status)

      Elseif _usb_status._usb_endp1 = 1 Then                '  

         Select Case _usb_rx_buffer(2)                      ' 
            Case 17
               If _usb_rx_buffer(3) = 8 Then                '   
                  Pwm2 = _usb_rx_buffer(4)
                  Ffb_motor = 1                             ' 
               End If
            Case 19                                         ' 
               Pwm2 = 128
               Ffb_motor = 0
         End Select

      End If

      _usb_status._usb_rtr = 1                              ' RTR-  (   )
      _usb_status._usb_rxc = 0                              ' RXC-

   End If

   If _usb_tx_status2._usb_txc = 1 Then                     '   

      '-----------------------    ---------------------------
      Wheel = 0
      For I = 1 To 4                                        '4    ""
         Temp_word = Getadc(0)
         Wheel = Wheel + Temp_word
      Next I

      '------------------------   -------------------------------
      Buttons = 0
      Gosub Clear_ports : Config Row0 = Output : Row0 = 0 : Waitus 50
         Buttons.15 = Not Col0                              ' "/\"
         Buttons.5 = Not Col1                               ' "L1"
         Buttons.0 = Not Col2                               ' "L3"
         Buttons.14 = Not Col3                              'Reverse Gear
         Buttons.10 = Not Col4                              'Gear 3
         Hat.0 = Not Col5                                   'Hat "1"

      Gosub Clear_ports : Config Row1 = Output : Row1 = 0 : Waitus 50
         Buffer_6.0 = Not Col0                              ' "[]"
         Buttons.4 = Not Col1                               ' "R1"
         Buttons.3 = Not Col2                               ' "R3"
         Buttons.11 = Not Col4                              'Gear 4
         Hat.1 = Not Col5                                   'Hat "2"

      Gosub Clear_ports : Config Row2 = Output : Row2 = 0 : Waitus 50
         Buffer_6.2 = Not Col0                              ' "O"
         Buttons.7 = Not Col1                               ' "L2"
         Buttons.1 = Not Col2                               ' "Select"
         Buttons.9 = Not Col3                               'Gear Up
         Buttons.12 = Not Col4                              'Gear 5
         Hat.2 = Not Col5                                   'Hat "3"

      Gosub Clear_ports : Config Row3 = Output : Row3 = 0 : Waitus 50
         Buffer_6.1 = Not Col0                              ' "X"
         Buttons.6 = Not Col1                               ' "R2"
         Buttons.2 = Not Col2                               ' "Start"
         Buttons.8 = Not Col3                               'Gear Down
         Buttons.13 = Not Col4                              'Gear Up
         Hat.3 = Not Col5                                   'Hat "4"


      Select Case Hat
         Case 0 : Wheel.15 = 1                              'Hat  
         'Case 1                                           ' /\ ,   = 0
         Case 2 : Wheel.13 = 1                              ' >
         Case 3 : Wheel.12 = 1                              ' /\  >
         Case 4 : Wheel.14 = 1                              ' \/
         Case 6
            Wheel.12 = 1 : Wheel.13 = 1                     ' >  \/
         Case 8
            Wheel.13 = 1 : Wheel.14 = 1                     ' <
         Case 9
            Wheel.12 = 1
            Wheel.13 = 1 : Wheel.14 = 1                     ' <  /\
         Case 12
            Wheel.12 = 1 : Wheel.14 = 1                     ' <  \/
      End Select

      '--------------------------   ----------------------------
      Accelerator = 0 : Brake = 0 : Clutch = 0
      For I = 1 To 4                                        '4    ""
         Temp_word = Getadc(1)                              ' ""
         Clutch = Clutch + Temp_word
         Temp_word = Getadc(2)                              ' ""
         Brake = Brake + Temp_word
         Temp_word = Getadc(3)                              ' ""
         Accelerator = Accelerator + Temp_word
      Next I
      Shift Clutch , Right , 5                              '  127
      Shift Brake , Right , 5                               '  127
      Shift Accelerator , Right , 5                         '  127

      Combined_pedals = Accelerator
      If Brake < 123 Then                                   ' ""   ""  " "
         Combined_pedals = 255 - Brake
      End If

      Buffer_6.3 = Accelerator.0                            '   
      Buffer_6.4 = Accelerator.1
      Buffer_6.5 = Accelerator.2
      Buffer_6.6 = Accelerator.3
      Buffer_6.7 = Accelerator.4
      Buffer_7.0 = Accelerator.5
      Buffer_7.1 = Accelerator.6
      Buffer_7.2 = Brake.0
      Buffer_7.3 = Brake.1
      Buffer_7.4 = Brake.2
      Buffer_7.5 = Brake.3
      Buffer_7.6 = Brake.4
      Buffer_7.7 = Brake.5
      Buffer_8.0 = Brake.6
      Buffer_8.1 = Clutch.0
      Buffer_8.2 = Clutch.1
      Buffer_8.3 = Clutch.2
      Buffer_8.4 = Clutch.3
      Buffer_8.5 = Clutch.4
      Buffer_8.6 = Clutch.5
      Buffer_8.7 = Clutch.6

      '-------------------------     --------------------------
      _usb_tx_buffer2(2) = Low(wheel)
      _usb_tx_buffer2(3) = High(wheel)
      _usb_tx_buffer2(4) = Low(buttons)
      _usb_tx_buffer2(5) = High(buttons)
      _usb_tx_buffer2(6) = Buffer_6
      _usb_tx_buffer2(7) = Buffer_7
      _usb_tx_buffer2(8) = Buffer_8
      _usb_tx_buffer2(9) = Combined_pedals
      Call Usb_send(_usb_tx_status2 , 8)
   End If

Loop

End
'===============================================================================
Clear_ports:                                                '  
Config Row0 = Input : Row0 = 1
Config Row1 = Input : Row1 = 1
Config Row2 = Input : Row2 = 1
Config Row3 = Input : Row3 = 1
Return

$include "Descriptors.inc"