$nocompile
'*******************************************************************************
'**************** ,   EEPROM  FLASH ******************
'                        !
'
#if _usb_use_eeprom = 1
   $eeprom
#else
   $data
#endif

' 
_usb_devicedescriptor:
Data 18 , 18 , _usb_desc_device , _usb_specl , _usb_spech , _usb_devclass
Data _usb_devsubclass , _usb_devprot , 8 , _usb_vidl , _usb_vidh , _usb_pidl
Data _usb_pidh , _usb_devrell , _usb_devrelh , _usb_imanufacturer
Data _usb_iproduct , _usb_iserial , _usb_numconfigs


'Retrieving the configuration descriptor also gets all the interface and
'endpoint descriptors for that configuration.  It is not possible to retrieve
'only an interface or only an endpoint descriptor.  Consequently, this is a
'large transaction of variable size.
_usb_configdescriptor:
Data _usb_descr_total , 9 , _usb_desc_config , _usb_descr_totall
Data _usb_descr_totalh , _usb_numifaces , _usb_confignum , _usb_iconfig
Data _usb_powered , _usb_maxpower

'_usb_IFaceDescriptor
Data 9 , _usb_desc_iface , _usb_ifaceaddr , _usb_alternate
Data _usb_ifaceendpoints , _usb_ifclass , _usb_ifsubclass , _usb_ifprotocol
Data _usb_iiface

#if _usb_hids > 0
'_usb_HIDDescriptor
Data _usb_hid_descr_len , _usb_desc_hid , _usb_hid_releasel , _usb_hid_releaseh
Data _usb_hid_country , _usb_hid_numdescriptors

'Next follows a list of bType and wLength bytes/words for each report and
'physical descriptor.  There must be at least 1 report descriptor.  In practice,
'There are usually 0 physical descriptors and only 1 report descriptor.
Data _usb_desc_report

Data 101 , 0

'End of report/physical descriptor list
#endif

#if _usb_endpoints > 1
'_usb_EndpointDescriptor
Data 7 , _usb_desc_endpoint , _usb_endp2attr , _usb_endp2type , 8 , 0
Data _usb_endp2interval
#endif

#if _usb_endpoints > 2
'_usb_EndpointDescriptor
Data 7 , _usb_desc_endpoint , _usb_endp3attr , _usb_endp3type , 8 , 0
Data _usb_endp3interval
#endif



#if _usb_hids > 0
_usb_hid_reportdescriptor:

Data 101
Data &H05 , &H01                                            '  Usage Page (Desktop),
Data &H09 , &H04                                            '  Usage (Joystik),
Data &HA1 , &H01                                            '  Collection (Application),
Data &HA1 , &H02                                            '      Collection (Logical),
Data &H75 , &H08                                            '          Report Size (8 bit),
Data &H95 , &H05                                            '          Report Count (5 field),
Data &H15 , &H00                                            '          Logical Minimum (0),
Data &H26 , &HFF , &H00                                     '          Logical Maximum (255),
Data &H35 , &H00                                            '          Physical Minimum (0),
Data &H46 , &HFF , &H00                                     '          Physical Maximum (255),
Data &H09 , &H30                                            '          Usage (X),
Data &H09 , &H31                                            '          Usage (Y),
Data &H09 , &H32                                            '          Usage (Z),
Data &H09 , &H32                                            '          Usage (Z),
Data &H09 , &H35                                            '          Usage (Rz),
Data &H81 , &H02                                            '              >>>> Input (Variable), *** Joysticks ***
Data &H75 , &H04                                            '          Report Size (4 bit),
Data &H95 , &H01                                            '          Report Count (1 field),
Data &H25 , &H07                                            '          Logical Maximum (7),
Data &H46 , &H3B , &H01                                     '          Physical Maximum (315),
Data &H65 , &H14                                            '          Unit (Degrees),
Data &H09 , &H39                                            '          Usage (Hat Switch),
Data &H81 , &H42                                            '              >>>> Input (Variable), *** Hat ***
Data &H65 , &H00                                            '          Unit (0),
Data &H75 , &H01                                            '          Report Size (1 bit),
Data &H95 , &H0C                                            '          Report Count (12 fields),
Data &H25 , &H01                                            '          Logical Maximum (1),
Data &H45 , &H01                                            '          Physical Maximum (1),
Data &H05 , &H09                                            '          Usage Page (Button),
Data &H19 , &H01                                            '          Usage Minimum (1),
Data &H29 , &H0C                                            '          Usage Maximum (12),
Data &H81 , &H02                                            '              >>>> Input (Variable), *** Buttons ***
Data &H06 , &H00 , &HFF                                     '          Usage Page (Vendor defined),
Data &H75 , &H01                                            '          Report Size (1 bit),
Data &H95 , &H08                                            '          Report Count (8 field),
Data &H25 , &H01                                            '          Logical Maximum (1),
Data &H45 , &H01                                            '          Physical Maximum (1),
Data &H09 , &H01                                            '          Usage (1),
Data &H81 , &H02                                            '              >>>> Input (Variable),
Data &HC0                                                   '      End Collection,
Data &HA1 , &H02                                            '      Collection (Logical),
Data &H75 , &H08                                            '          Report Size (8 bit),
Data &H95 , &H07                                            '          Report Count (7 fields),
Data &H46 , &HFF , &H00                                     '          Physical Maximum (255),
Data &H26 , &HFF , &H00                                     '          Logical Maximum (255),
Data &H09 , &H02                                            '          Usage (2),
Data &H91 , &H02                                            '              <<<< Output (Variable), *** Vibration & Control ***
Data &HC0                                                   '      End Collection,
Data &HC0                                                   '  End Collection

#endif

'*****************************String descriptors********************************
'Yes, they MUST be written like "t","e","s","t".  Doing so pads them with
'0's.  If you write it like "test," I promise you it won't work.

'Default language descriptor (index 0)
_usb_langdescriptor:
Data 4 , 4 , _usb_desc_string , 09 , 04                     '&h0409 = English

'Manufacturer Descriptor (unicode)
_usb_mandescriptor:
Data 22 , 22 , _usb_desc_string
Data "M" , "C" , "S" , "-" , "B" , "a" , "s" , "c" , "o" , "m"

'Product Descriptor (unicode)
_usb_proddescriptor:
'Data 20 , 20 , _usb_desc_string
'Data "F" , "F" , "B" , " " , "W" , "h" , "e" , "e" , "l"
' Generic   USB  Joystick
Data 52 , 52 , _usb_desc_string
Data &H47 , &H00 , &H65 , &H00 , &H6E , &H00 , &H65 , &H00 , &H72 , &H00
Data &H69 , &H00 , &H63 , &H00 , &H20 , &H00 , &H20 , &H00 , &H20 , &H00
Data &H55 , &H00 , &H53 , &H00 , &H42 , &H00 , &H20 , &H00 , &H20 , &H00
Data &H4A , &H00 , &H6F , &H00 , &H79 , &H00 , &H73 , &H00 , &H74 , &H00
Data &H69 , &H00 , &H63 , &H00 , &H6B , &H00 , &H20 , &H00 , &H20 , &H00
Data &H00 , 0

'*******************************************************************************
'******************************** Subroutines **********************************
Sub Usb_processsetup(txstate As Byte)

Senddescriptor = 0

   'Control transfers reset the sync bits like so
   Txstate = _usb_setup_sync

   'These are the standard device, interface, and endpoint requests that the
   'USB spec requires that we support.
   Select Case _usb_rx_buffer(2)
      '  
      Case &B10000000:
         Select Case _usb_rx_buffer(3)
           ' Case _usb_req_get_status:                       ' 00 -   

            Case _usb_req_get_descriptor:
               Select Case _usb_rx_buffer(5)
                  Case _usb_desc_device:
                     '  
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_devicedescriptor
                     #else
                        Restore _usb_devicedescriptor
                     #endif
                     Senddescriptor = 1
                  Case _usb_desc_config:
                     '  
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_configdescriptor
                     #else
                        Restore _usb_configdescriptor
                     #endif
                     Senddescriptor = 1
                  Case _usb_desc_string:
                     Select Case _usb_rx_buffer(4)
                        Case 0:
                           '   
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_langdescriptor
                           #else
                              Restore _usb_langdescriptor
                           #endif
                           Senddescriptor = 1
                        Case 1:
                           '  
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_mandescriptor
                           #else
                              Restore _usb_mandescriptor
                           #endif
                           Senddescriptor = 1
                        Case 2:
                           '  
                           #if _usb_use_eeprom = 1
                              Readeeprom _usb_eepromaddrl , _usb_proddescriptor
                           #else
                              Restore _usb_proddescriptor
                           #endif
                           Senddescriptor = 1
                     End Select
               End Select
'            CASE _usb_REQ_GET_CONFIG:
         End Select
      Case &B00000000:
         Select Case _usb_rx_buffer(3)
'            CASE _usb_REQ_CLEAR_FEATURE: ' 01  
'            CASE _usb_REQ_SET_FEATURE:   ' 03  
            Case _usb_req_set_address:
               'USB status reporting for control writes
               Call Usb_send(txstate , 0)
               While Txstate._usb_txc = 0 : Wend
               'We are now addressed.
               _usb_deviceid = _usb_rx_buffer(4)
'            CASE _usb_REQ_SET_DESCRIPTOR:
            Case _usb_req_set_config:
               'Have to do status reporting
               Call Usb_send(txstate , 0)
         End Select
      '  
      Case &B10000001:
         Select Case _usb_rx_buffer(3)
'            CASE _usb_REQ_GET_STATUS:
'            CASE _usb_REQ_GET_IFACE:
            Case _usb_req_get_descriptor
            '_usb_rx_buffer(4)    (5)  
               Select Case _usb_rx_buffer(5)
                  Case _usb_desc_report:
                     #if _usb_use_eeprom = 1
                        Readeeprom _usb_eepromaddrl , _usb_hid_reportdescriptor
                     #else
                        Restore _usb_hid_reportdescriptor
                     #endif
                     Senddescriptor = 1

'                  CASE _usb_DESC_PHYSICAL

'                  CASE _USB_DESC_HID

               End Select
         End Select
      Case &B00100001:
         'Class specific SET requests
         Select Case _usb_rx_buffer(3)
            'CASE _usb_REQ_SET_REPORT:
            Case _usb_req_set_idle:
               Idlemode = 1
               'Do status reporting
               Call Usb_send(txstate , 0)
            'CASE _usb_REQ_SET_PROTOCOL:
         End Select
   End Select

   If Senddescriptor = 1 Then
      Call Usb_senddescriptor(txstate , _usb_rx_buffer(8))
   End If

End Sub

Sub Usb_senddescriptor(txstate As Byte , Maxlen As Byte)
   'Break the descriptor into packets and send to TxState
   Local Size As Byte
   Local I As Byte
   Local J As Byte
   Local Timeout As Word

   #if _usb_use_eeprom = 1
      'EEPROM access is a little funky.  The size has already been fetched
      'and stored in _usb_EEPROMADDRL, and the address of the descriptor
      'is now in the EEAR register pair.

      Size = _usb_eepromaddrl

      'Fetch the location of the descriptor and use it as an address pointer
      push R24
      in R24, EEARL
      sts {_USB_EEPROMADDRL}, R24
      in R24, eearH
      sts {_USB_EEPROMADDRH}, R24
      pop R24

   #else
      Read Size
   #endif


   If Maxlen < Size Then Size = Maxlen

   I = 2
   For J = 1 To Size
      Incr I
      #if _usb_use_eeprom = 1
         Incr _usb_eepromaddr
         Readeeprom Txstate(i) , _usb_eepromaddr
      #else
         Read Txstate(i)
      #endif

      If I = 10 Or J = Size Then
         I = I - 2
         Call Usb_send(txstate , I)
         While Txstate._usb_txc = 0
            Timeout = 0
            'To prevent an infinite loop, check for reset here
            While _usb_pin._usb_dminus = 0
               Incr Timeout
               If Timeout = 1000 Then                       '
                  Call Usb_reset()
                  Exit Sub
               End If
            Wend
         Wend
         I = 2
      End If
   Next
End Sub

Sub Usb_send(txstate As Byte , Byval Count As Byte)
   'Calculates and adds the CRC16,adds the DATAx PID,
   'and signals to the ISR that the data is ready to be sent.
   '
   '"Count" is the DATA payload size.  Range is 0 to 8. Do not exceed 8!

   'Reset all the flags except TxSync and RxSync
   Txstate = Txstate And _usb_syncmask
   'Calculate the 16-bit CRC
   _usb_crc = 0
   If Count <> 0 Then
      _usb_crc = Crc16uni(txstate(3) , Count , &HFFFF , &H8005 , 1 , 1)
      Toggle _usb_crc
   End If
   'Bytes to transmit will be PID + DATA payload + CRC16
   Count = Count + 3
   Txstate = Txstate + Count
   Txstate(count) = Low(_usb_crc)
   Incr Count
   Txstate(count) = High(_usb_crc)
   'Add the appropriate DATAx PID
   Txstate(2) = _usb_pid_data1
   If Txstate._usb_txsync = 0 Then
      Txstate(2) = _usb_pid_data0
   End If
   'The last step is to signal that the packet is Ready To Transmit
   Txstate._usb_rtt = 1
   Txstate._usb_txc = 0
End Sub

Sub Usb_reset()
'Gosub Send_data
   'Reset the receive flags
   _usb_status._usb_rtr = 1
   _usb_status._usb_rxc = 0
   'Reset the transmit flags
   _usb_tx_status = _usb_endp_init
   #if Varexist( "_usb_Endp2Addr")
   _usb_tx_status2 = _usb_endp_init
   #endif
   #if Varexist( "_usb_Endp3Addr")
   _usb_tx_status3 = _usb_endp_init
   #endif
   'Reset the device ID to 0
   _usb_deviceid = 0
   Idlemode = 0
End Sub